//-----------------------------------------------------------------------------------------------------
//sPPZ_levels_v1_0.mq4
//   PPZ  4 
//    Dsergx-sPA_v2.3.mq4
// : Dserg (http://www.mql4.com/ru/users/Dserg)
//: midorum (http://www.mql4.com/ru/users/midorum)
// : http://forum.mql4.com/ru/29968
//-----------------------------------------------------------------------------------------------------
//    ,    .    .
//        4 PPZ    .
//    ,      (   ),      -  (   ).
//           .
//-----------------------------------------------------------------------------------------------------
// :
//-     
//-  
#property copyright "Dserg, midorum, 2012"
#property link      "http://forum.mql4.com/ru/29968"
#property show_inputs

#define @fractals_max 1000
#define @levels_max 4

extern string a1 = "   ";
extern int Nbars=150;
extern string a2 = "  () ";
extern int Nfirst=0;
extern string a3 = "     ";
extern double minDiff=300.0;
extern string a4 = "     ";
extern int minBars=5;
extern string a5 = "     ";
extern bool DeleteAll=false;

double fr[@fractals_max];// 
int ind_fr[@fractals_max];//  
double level[@levels_max];// ppz-
double disp[@levels_max];// 
double average,cur_disp,diff;

//-----------------------------------------------------------------------------------------------------
int start()
{
   int i,j,k,l,m;
   int _sel_fr[@levels_max];
   int _found;
   string _name,_period;
   
   if(DeleteAll)
   {
      ClearChart();
      return(0);
   }   
   
   if(Nbars>500)
   { 
      Comment("Too much bars to calulate, try < 500");
      return(0);
   }
   if(Nbars>Bars) Nbars=Bars;
   ArrayInitialize(disp,999999999);
   diff=minDiff*Point;
   datetime _start_time=TimeLocal();
   
   // ,   
   // 1 -    2    
   for(i=Nfirst,j=0; i<Nfirst+Nbars; i++)
   {
      fr[j]=iFractals(NULL,0,MODE_UPPER,i);
      if (fr[j]!=0)
      {
         ind_fr[j]=i;
         j++;
      }
      fr[j]=iFractals(NULL,0,MODE_LOWER,i);
      if (fr[j]!=0)
      {
         ind_fr[j]=i;
         j++;
      }
   }
   // 2 - 
/*   for(i=Nfirst,j=0; i<Nfirst+Nbars; i++)
   {
      fr[j]=iFractals(NULL,0,MODE_UPPER,i);
      if (fr[j]==0) fr[j]=iFractals(NULL,0,MODE_LOWER,i);
      if (fr[j]!=0)
      {
         ind_fr[j]=i;
         j++;
      }
   }
*/
   _found=j;//  
   
   // PPZ  4- 
   //               
   for(m=0; m<@levels_max; m++)
   {
      for(i=0; i<_found-3; i++)//@levels_max
      {
         if(fr[i]==0) continue;
         for(j=i+1; j<_found-2; j++)//@levels_max
         {
            if(fr[j]==0) continue;
            if(MathAbs(ind_fr[i]-ind_fr[j])>minBars)//@levels_max
            {
               for(k=j+1; k<_found-1; k++)//@levels_max
               {
                  if(fr[k]==0) continue;
                  if (MathAbs(ind_fr[i]-ind_fr[k])>minBars && MathAbs(ind_fr[k]-ind_fr[j])>minBars)//@levels_max
                  {
                     for(l=k+1; l<_found; l++)//@levels_max
                     {
                        if(fr[l]==0) continue;
                        if (MathAbs(ind_fr[i]-ind_fr[l])>minBars && MathAbs(ind_fr[j]-ind_fr[l])>minBars && MathAbs(ind_fr[k]-ind_fr[l])>minBars)//@levels_max
                        {
                           average=(fr[i]+fr[j]+fr[k]+fr[l])/4;//@levels_max
                           cur_disp=MathPow(fr[i]-average,2)+MathPow(fr[j]-average,2)+MathPow(fr[k]-average,2)+MathPow(fr[l]-average,2);
                           if(cur_disp<disp[m] && CheckDiff(m))
                           {
                              disp[m]=cur_disp;
                              level[m]=average;
                              _sel_fr[0]=i;_sel_fr[1]=j;_sel_fr[2]=k;_sel_fr[3]=l;//@levels_max
                           }
                        }
                     }
                  }
               }
            }
         }
      }
      fr[_sel_fr[0]]=0;fr[_sel_fr[1]]=0;fr[_sel_fr[2]]=0;fr[_sel_fr[3]]=0;// ,    //@levels_max
   }   
   
   switch(Period())
   {
   case PERIOD_M1:
      _period="M1";
      break;
   case PERIOD_M5:
      _period="M5";
      break;
   case PERIOD_M15:
      _period="M15";
      break;
   case PERIOD_M30:
      _period="M30";
      break;
   case PERIOD_H1:
      _period="H1";
      break;
   case PERIOD_H4:
      _period="H4";
      break;
   case PERIOD_D1:
      _period="D1";
      break;
   case PERIOD_W1:
      _period="W1";
      break;
   case PERIOD_MN1:
      _period="MN1";
   }

   //@levels_max
   _name=_period+"_PPZ0";
   ObjectDelete(_name);
   if(!ObjectCreate(_name,OBJ_HLINE,0,0,NormalizeDouble(level[0],Digits)))
   {
      Comment("ERROR");
      return(0);
   }
   ObjectSet(_name,OBJPROP_COLOR,DeepSkyBlue);
   ObjectSet(_name,OBJPROP_STYLE,STYLE_DOT);
   ObjectSetText(_name,"disp:"+DoubleToStr(disp[0],8));

   _name=_period+"_PPZ1";
   ObjectDelete(_name);
   if(!ObjectCreate(_name,OBJ_HLINE,0,0,NormalizeDouble(level[1],Digits)))
   {
      Comment("ERROR");
      return(0);
   }
   ObjectSet(_name,OBJPROP_COLOR,DeepPink);
   ObjectSet(_name,OBJPROP_STYLE,STYLE_DOT);
   ObjectSetText(_name,"disp:"+DoubleToStr(disp[1],8));

   _name=_period+"_PPZ2";
   ObjectDelete(_name);
   if(!ObjectCreate(_name,OBJ_HLINE,0,0,NormalizeDouble(level[2],Digits)))
   {
      Comment("ERROR");
      return(0);
   }
   ObjectSet(_name,OBJPROP_COLOR,Gold);
   ObjectSet(_name,OBJPROP_STYLE,STYLE_DOT);
   ObjectSetText(_name,"disp:"+DoubleToStr(disp[2],8));

   _name=_period+"_PPZ3";
   ObjectDelete(_name);
   if(!ObjectCreate(_name,OBJ_HLINE,0,0,NormalizeDouble(level[3],Digits)))
   {
      Comment("ERROR");
      return(0);
   }
   ObjectSet(_name,OBJPROP_COLOR,Tomato);
   ObjectSet(_name,OBJPROP_STYLE,STYLE_DOT);
   ObjectSetText(_name,"disp:"+DoubleToStr(disp[3],8));

   _name=_period+"_END";
   ObjectDelete(_name);
   if(!ObjectCreate(_name,OBJ_VLINE,0,iTime(NULL,0,Nbars+Nfirst),0))
   {
      Comment("ERROR");
      return(0);
   }
   ObjectSet(_name,OBJPROP_COLOR,DarkKhaki);
   ObjectSet(_name,OBJPROP_STYLE,STYLE_DOT);

   //@levels_max
   Print("Calculation of PPZ done: PPZ0-" + DoubleToStr(level[0],5) + "   PPZ1-" + DoubleToStr(level[1],5) + "   PPZ2-" + DoubleToStr(level[2],5) + "   PPZ3-" + DoubleToStr(level[3],5) + "   Time-" + (TimeLocal()-_start_time) + " sec.");
   
   return(0);
}
//-----------------------------------------------------------------------------------------------------
bool CheckDiff(int _index)
{
   int i;
   for(i=0; i<_index; i++)
   {
      if(MathAbs(average-level[i])<diff) return(false);
   }
   return(true);
}
//-----------------------------------------------------------------------------------------------------
void ClearChart()
{
   int i;
   string _name;
   for(i=ObjectsTotal()-1;i>=0;i--)
   {
      _name="_PPZ";
      if(StringFind(ObjectName(i),_name)!=-1)
      {
         ObjectDelete(ObjectName(i));
      }
      _name="_END";
      if(StringFind(ObjectName(i),_name)!=-1)
      {
         ObjectDelete(ObjectName(i));
      }
   }
   return;
}
//-----------------------------------------------------------------------------------------------------

